import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.TexturePaint;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

/*
 * Created on 19.05.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author siggi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DrawPanel extends JPanel {
	private int prefWidth, prefHeight;
	private Shape shape;
	private Color color;
	private boolean texturePaint;
	private boolean gradientPaint;
	private AffineTransform rotateAT;
	private int angle;
	private boolean antialiasing, dithering;

	public DrawPanel(int w, int h) {
		prefWidth = w; prefHeight = h;
		shape = null;
		color = null;
		texturePaint = false;
		gradientPaint = false;
		angle = 0;
		dithering = false;
		antialiasing = false;
	}
	
	public void paintComponent(Graphics g) {
		System.out.println("paintComponent aufgerufen");
		
		// Wichtig: Zuerst immer die super-Methode aufrufen! (sonst muss man alles selbst zeichnen, inkl. Hintergrund)
		super.paintComponent(g);

		if (shape != null) {			
			Graphics2D g2 = (Graphics2D) g;
			
			// Rendering Optionen setzen
			if (antialiasing) {
				g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
			} else {
				g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
			}
			if (dithering) {
				g2.setRenderingHint(RenderingHints.KEY_DITHERING,RenderingHints.VALUE_DITHER_ENABLE);
			} else {
				g2.setRenderingHint(RenderingHints.KEY_DITHERING,RenderingHints.VALUE_DITHER_DISABLE);
			}

			// affine Transformation um gewnschten Winkel
			rotateAT = AffineTransform.getRotateInstance(angle*2*Math.PI/360,
					shape.getBounds2D().getX()+shape.getBounds2D().getWidth()/2,
					shape.getBounds2D().getY()+shape.getBounds2D().getHeight()/2);
			g2.transform(rotateAT);
			
			// Form zeichnen
			g2.setColor(Color.WHITE);
			g2.setStroke(new BasicStroke(3.0f));
			g2.draw(shape);
			
			// Form ausfllen
			if (texturePaint) {
				// Textur erstellen
				BufferedImage bi = new BufferedImage(20, 20, BufferedImage.TYPE_INT_RGB);
				Graphics2D big2 = bi.createGraphics();
				big2.setColor(Color.BLACK);
				big2.fillRect(0, 0, 20, 20);
				big2.setColor(Color.BLUE);
				big2.fillOval(0, 0, 15, 15);
				Rectangle r = new Rectangle(0, 0, 20, 20);
				g2.setPaint(new TexturePaint(bi, r));
				g2.fill(shape);
			} else if (gradientPaint) {
				// Gradient erstellen
				GradientPaint gp = new GradientPaint(
						(int)(shape.getBounds().getX()),
						(int)(shape.getBounds().getY()),
						Color.GREEN,
						(int)(shape.getBounds().getX()+shape.getBounds().getWidth()),
						(int)(shape.getBounds().getY()+shape.getBounds().getHeight()),
						Color.RED
						);
				g2.setPaint(gp);
				g2.fill(shape);
			} else if (color!=null) {
				// einfarbig fllen
				g2.setPaint(color);
				g2.fill(shape);
			}
		}
	}
	/**
	 * @return Returns the angle.
	 */
	public int getAngle() {
		return angle;
	}
	/**
	 * @param angle The angle to set.
	 */
	public void setAngle(int angle) {
		this.angle = angle;
	}
	/**
	 * @return Returns the antialiasing.
	 */
	public boolean isAntialiasing() {
		return antialiasing;
	}
	/**
	 * @param antialiasing The antialiasing to set.
	 */
	public void setAntialiasing(boolean antialiasing) {
		this.antialiasing = antialiasing;
	}
	/**
	 * @return Returns the color.
	 */
	public Color getColor() {
		return color;
	}
	/**
	 * @param color The color to set.
	 */
	public void setColor(Color color) {
		this.color = color;
	}
	/**
	 * @return Returns the dithering.
	 */
	public boolean isDithering() {
		return dithering;
	}
	/**
	 * @param dithering The dithering to set.
	 */
	public void setDithering(boolean dithering) {
		this.dithering = dithering;
	}
	/**
	 * @return Returns the gradientPaint.
	 */
	public boolean isGradientPaint() {
		return gradientPaint;
	}
	/**
	 * @param gradientPaint The gradientPaint to set.
	 */
	public void setGradientPaint(boolean gradientPaint) {
		this.gradientPaint = gradientPaint;
	}
	/**
	 * @return Returns the shape.
	 */
	public Shape getShape() {
		return shape;
	}
	/**
	 * @param shape The shape to set.
	 */
	public void setShape(Shape shape) {
		this.shape = shape;
	}
	/**
	 * @return Returns the texturePaint.
	 */
	public boolean isTexturePaint() {
		return texturePaint;
	}
	/**
	 * @param texturePaint The texturePaint to set.
	 */
	public void setTexturePaint(boolean texturePaint) {
		this.texturePaint = texturePaint;
	}
}
